import random
import pygame
import time
import math


def upRange(start, stop, step):
  while start <= stop:
    yield start
    start += abs(step)

def downRange(start, stop, step):
  while start >= stop:
    yield start
    start -= abs(step)


pygame.init()
w,h = 1540,800
window1 = pygame.display.set_mode(size=(w,h), flags=0, depth=0)
f1 = pygame.font.Font("freesansbold.ttf",20)
f2 = pygame.font.Font("freesansbold.ttf",40)
f1.set_bold(False)
f1.set_italic(False)
f1.set_underline(False)
pygame.display.set_caption("tcs")
c = 0
while not ((c == 4)):
    window1.fill((255,255,255))
    for a in (0 <= int(h)) and upRange(0, int(h), 20) or downRange(0, int(h), 20):
        pygame.draw.line(window1, (200,200,200), (0,a), (w,a), 1)
    for a in (0 <= int(w)) and upRange(0, int(w), 20) or downRange(0, int(w), 20):
        pygame.draw.line(window1, (200,200,200), (a,0), (a,h), 1)
    window1.blit(f2.render("PRESS \"UP ARROW\" TO TURN UP", False, (0,0,0,1)) ,(0,h-40*4))
    window1.blit(f2.render("PRESS \"DONE ARROW\" TO TURN DONE", False, (0,0,0,1)) ,(0,h-40*3))
    window1.blit(f2.render("PRESS \"LEFT ARROW\" TO TURN LEFT", False, (0,0,0,1)) ,(0,h-40*2))
    window1.blit(f2.render("PRESS \"RIGHT ARROW\" TO TURN RIGHT", False, (0,0,0,1)) ,(0,h-40*1))
    pygame.display.flip()
    time.sleep(4)
    snake_list = []
    snake_head = (0,0)
    food_list = []
    for index in range(10):
        food = (((random.randint(0, ((w-20) / 20))) * 20),((random.randint(0, ((h-20)/ 20))) * 20))
        while not ((not (food in tuple(food_list) or (food in tuple(snake_list) or (snake_head == food))))):
            food = (((random.randint(0, ((w-20) / 20))) * 20),((random.randint(0, ((h-20)/ 20))) * 20))
        food_list.append(food)
    direction = "right"
    score = 2
    t = 0
    a = 0
    b = 0
    c = 0
    while not (((c == 2) or ((c == 3) or (c == 4)))):
        window1.fill((255,255,255))
        for a in (0 <= int(h)) and upRange(0, int(h), 20) or downRange(0, int(h), 20):
            pygame.draw.line(window1, (200,200,200), (0,a), (w,a), 1)
        for a in (0 <= int(w)) and upRange(0, int(w), 20) or downRange(0, int(w), 20):
            pygame.draw.line(window1, (200,200,200), (a,0), (a,h), 1)
        for a in snake_list:
            x,y = a
            pygame.draw.rect(window1, (200,200,200),((x,y),(20,20)), 0)
        for a in food_list:
            x,y = a
            pygame.draw.rect(window1, (0,255,0),((x,y),(20,20)), 0)
        x,y = snake_head
        if (direction == "right"):
            x,y = x+20,y
        elif (direction == "left"):
            x,y = x-20,y
        elif (direction == "up"):
            x,y = x,y-20
        elif (direction == "down"):
            x,y = x,y+20
        snake_head = x,y
        if snake_head in tuple(snake_list):
            if (not (snake_list.index(snake_head) == (len(snake_list) - 1))):
                c = 3
        if snake_head in tuple(food_list):
            pygame.mixer.Sound("咬.wav").set_volume(10 / 100)
            pygame.mixer.Sound("咬.wav").play()
            food_list.pop(food_list.index(snake_head))
            score = score + 1
            food = (((random.randint(0, ((w-20) / 20))) * 20),((random.randint(0, ((h-20)/ 20))) * 20))
            while not ((not (food in tuple(food_list) or (food in tuple(snake_list) or (snake_head == food))))):
                food = (((random.randint(0, ((w-20) / 20))) * 20),((random.randint(0, ((h-20)/ 20))) * 20))
            food_list.append(food)
        if (not (score > (len(snake_list) + 1))):
            snake_list.pop(0)
        snake_list.append(snake_head)
        pygame.draw.rect(window1, (255,0,0),((x,y),(20,20)), 0)
        events = pygame.event.get()
        for e in events:
            if (e.type == pygame.QUIT):
                pygame.quit()
            elif (e.type == pygame.KEYDOWN):
                if (e.key == pygame.K_p):
                    window1.blit(f2.render("PRESS P TO CONTINU", False, (0,0,0,1)) ,(0,0))
                    window1.blit(f2.render("PRESS R TO RESTART", False, (0,0,0,1)) ,(0,40))
                    window1.blit(f2.render("PRESS ESC TO ESCAPE", False, (0,0,0,1)) ,(0,80))
                    pygame.display.flip()
                    c = 0
                    while not ((c > 0)):
                        b = pygame.event.get()
                        for a in b:
                            if (a.type == pygame.KEYUP):
                                c = 1
                    c = 0
                    while not ((c > 0)):
                        b = pygame.event.get()
                        for a in b:
                            if (a.type == pygame.KEYDOWN):
                                if (a.key == pygame.K_p):
                                    c = 1
                                if (a.key == pygame.K_r):
                                    c = 2
                                if (a.key == pygame.K_ESCAPE):
                                    c = 4
                    if (c == 1):
                        c = 0
                elif (e.key == pygame.K_UP):
                    if (not (direction == "down")):
                        direction = "up"
                elif (e.key == pygame.K_DOWN):
                    if (not (direction == "up")):
                        direction = "down"
                elif (e.key == pygame.K_RIGHT):
                    if (not (direction == "left")):
                        direction = "right"
                elif (e.key == pygame.K_LEFT):
                    if (not (direction == "right")):
                        direction = "left"
        window1.blit(f1.render((str("score:") + str(score)), False, (0,0,0,0.5)) ,(0,0))
        window1.blit(f1.render((str("time:") + str((math.floor(t)))), False, (0,0,0,0.5)) ,(0,20))
        pygame.display.flip()
        time.sleep(0.05)
        t = t + 0.05
    while not (((c == 2) or (c == 4))):
        window1.blit(f2.render("PRESS R TO RESTART", False, (0,0,0,1)) ,(0,40))
        window1.blit(f2.render("PRESS ESC TO ESCAPE", False, (0,0,0,1)) ,(0,80))
        pygame.display.flip()
        events = pygame.event.get()
        for e in events:
            if (e.type == pygame.KEYDOWN):
                if (e.key == pygame.K_r):
                    c = 2
                elif (e.key == pygame.K_ESCAPE):
                    c = 4
pygame.quit()
